// ============================================================================================
// CN[ht@C
// ============================================================================================
#include <stdlib.h>
#include "audioeffectx.h"

#include "CMidiMsg.h"
#include "CVoice.h"


// ============================================================================================
// ݌v̋L
// ============================================================================================
#define MY_VST_INPUT_NUM   2 //͐Bm=1AXeI=2
#define MY_VST_OUTPUT_NUM  2 //o͐Bmo=1AXeIo=2

#define MY_VST_UNIQUE_ID  'SMPL' //j[NID
                                 //Jꍇ͈ȉURLŔsꂽj[NID͂B
                                 //http://ygrabit.steinberg.de/~ygrabit/public_html/index.html

#define MY_VST_PRESET_NUM    1 //vZbgvO̐
#define MY_VST_PARAMETER_NUM 0 //p[^̐

#define MAX_OSCILLATORS 8 // IV[^̐(ő唭)
// ============================================================================================
// VST̊{ƂȂNX
// ============================================================================================
class MySynthSampleVST : public AudioEffectX , public CMidiMsg
{
protected:
	CVoice osc[MAX_OSCILLATORS];
public:
	MySynthSampleVST (audioMasterCallback audioMaster);

	// M郁o[֐
	virtual void processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames);
	virtual void processReplacing2 (float* inL, float* inR, float* outL, float* outR, VstInt32 sampleFrames);

	// MIDIbZ[WzXgAvP[V󂯎邽߂̃o[֐
	VstInt32 processEvents (VstEvents* events);

	virtual void onMidiKeyOn  (unsigned char channel, unsigned char noteNo, unsigned char velo);
	virtual void onMidiKeyOff (unsigned char channel, unsigned char noteNo, unsigned char velo);
};

// ============================================================================================
// VST𐶐邽߂̊֐
// ============================================================================================
AudioEffect* createEffectInstance (audioMasterCallback audioMaster)
{
	//newłVST𐶐|C^Ԃ
	return new MySynthSampleVST (audioMaster);
}

// ============================================================================================
// VST̏
// ============================================================================================
MySynthSampleVST::MySynthSampleVST (audioMasterCallback audioMaster)
: AudioEffectX (audioMaster, MY_VST_PRESET_NUM, MY_VST_PARAMETER_NUM)
{
	//VST̏sB

	//ȉ̊֐Ăяoē͐Ao͐̏ݒ肷B
	//KĂяoȂ΂ȂȂB
	setNumInputs (MY_VST_INPUT_NUM);    //͐̐ݒ
	setNumOutputs (MY_VST_OUTPUT_NUM);  //o͐̐ݒ
	setUniqueID (MY_VST_UNIQUE_ID);     //j[NID̐ݒ

	isSynth (true);          //VSTSynthǂ̃tOݒB
	                         //Synth̏ꍇctrueAEffectoȑꍇcfalse

	canProcessReplacing ();  //VST\ǂ̃tOݒB
	                         //sȂVST͂Ȃ̂ŕK̊֐ĂяoB

	//L̊֐Ăяoɏs
}


// ============================================================================================
// M
// ============================================================================================
void MySynthSampleVST::processReplacing (float** inputs, float** outputs, VstInt32 sampleFrames)
{
	//́Ao͂2zœnB
	//͂-1.0f`1.0f̊ԂœnB
	//o͂-1.0f`1.0f̊ԂŏޕKvB
	//sampleFramesobt@̃TCY
	float* inL  = inputs[0];  // p
	float* inR  = inputs[1];  // Ep
	float* outL = outputs[0]; //o p
	float* outR = outputs[1]; //o Ep

	// ꂽt[
	VstInt32 processedFrames = 0;

	while(getMidiMessageNum() > 0)
	{
		// ׂt[
		VstInt32 Frames = getNextDeltaFrames() - processedFrames;
		processReplacing2 (inL, inR, outL, outR, Frames);

		// MIDIbZ[W̏s
		midiProc();

		// ꂽt[vZ
		// ɉMobt@̃|C^ɂĂi߂B
		processedFrames += Frames;
		inL  += Frames;
		inR  += Frames;
		outL += Frames;
		outR += Frames;
	}

	processReplacing2 (inL, inR, outL, outR, sampleFrames - processedFrames);
}

void MySynthSampleVST::processReplacing2 (float* inL, float* inR, float* outL, float* outR, VstInt32 sampleFrames)
{
	for (int i = 0; i < sampleFrames; i++)
	{
		//ŉsB
		float out = 0.0f;
		float volume = 1.0 / (double)MAX_OSCILLATORS;

		// eIV[^̐U擾Ao͂ɑ킹B
		for(int j = 0; j < MAX_OSCILLATORS; j++)
		{
			// IV[^̐U擾B
			out += osc[j].amplitude();

			// IV[^̏ԂXVB
			osc[j].update();
		}

		//o̓obt@֏ށB
		outL[i] = out * volume;
		outR[i] = out * volume;
	}
}

// MIDIbZ[WVSTɕۑB
// processReplacing()̑OɕK1xĂяoB
VstInt32 MySynthSampleVST::processEvents (VstEvents* events)
{
	// MIDĨXg܂B
	clearMidiMsg();

	int loops = (events->numEvents);

	// VSTCxg̉񐔂[v܂킷B
	for (int i = 0;i < loops; i++)
	{
		// ^ꂽCxgMIDIȂmidimsgbufɃXgbN
		if ((events->events[i])->type == kVstMidiType)
		{
			VstMidiEvent *midievent = (VstMidiEvent*)(events->events[i]);
			if( !addMidiMsg(midievent) )
			{
				break;
			}
		}
	}

	//@1ԂȂ΂ȂȂ
	return 1;
}

// ============================================================================================
// MIDIbZ[W
// ============================================================================================
void MySynthSampleVST::onMidiKeyOn  (unsigned char channel, unsigned char noteNo, unsigned char velo)
{
	// OFFԂ̃IV[^T
	for(int i = 0; i < MAX_OSCILLATORS; i++)
	{
		if(osc[i].getStatus() == VOICE_STATE_OFF)
		{
			// OFFԂ̃IV[^ONɂČI
			osc[i].start(noteNo);
			break;
		}
	}
}

void MySynthSampleVST::onMidiKeyOff (unsigned char channel, unsigned char noteNo, unsigned char velo)
{
	// ONԂłm[gNoƈvIV[^T
	for(int i = 0; i < MAX_OSCILLATORS; i++)
	{
		if(osc[i].getStatus() == VOICE_STATE_ON && osc[i].getNoteNo() == noteNo)
		{
			// ONԂ̃IV[^OFFɂČI
			osc[i].stop();
			break;
		}
	}
}
